typedef enum {
    LINEN_AMP = 0,
    LINEN_ATT,
    LINEN_SUS,
    LINEN_REL,\
    LINEN_NUM_PARAMS
} LINEN_PARAMS;

typedef struct {
    double *out;

    double env;
    double amp;
    double inc[4];/* increment for each stage */

    int samples[4]; /* number of samples for each stage */
    int counter;
    int stage; // 0=att  1=sus  2=rel
    int sr;
} LINEN_DATA;

void *linen_construct(int sr, double amp, double att, double sus, double rel);

void linen_process(void *data);

void linen_destroy(void *data);

void linen_set_param(void *data, int index, double value);

double *linen_get_input(void *data, int index);

void linen_set_output(void *data, int index, double *out_buffer);

