#include <inttypes.h>

typedef enum {
    SINOSC_FREQ = 0,
    SINOSC_AMP,
    SINOSC_NUM_PARAMS
} SINOSC_PARAMS;

#define SINOSC_BUFFER_SIZE 4096

typedef struct {
    double *freq;
    double *amp;
    double *out;
    uint64_t phs;
    uint64_t inc;
    uint64_t lobits;

    double buffer[SINOSC_BUFFER_SIZE];
    int sr;
} SINOSC_DATA;

void *sinosc_construct(int sr, double freq, double amp);

void sinosc_process(void *data);

void sinosc_destroy(void *data);

void sinosc_set_param(void *data, int index, double value);

double *sinosc_get_input(void *data, int index);

void sinosc_set_output(void *data, int index, double *out_buffer);




